﻿Imports System.IO
Imports System.Data.OleDb

Public Class frmMain
    Dim connstring As String = "Provider=Microsoft.ACE.OLEDB.12.0;Data Source=|datadirectory|\picdb.mdb"
    Dim connect As New OleDbConnection

#Region "Connections"
    Public Sub openconnection()
        If connect.State = ConnectionState.Closed Then
            connect.ConnectionString = connstring
            Try
                connect.Open()
            Catch ex As Exception
                MsgBox("Error. No connection to server", MessageBoxIcon.Error, "Connection Error")
                Exit Sub
            End Try
        ElseIf connect.State = ConnectionState.Open Then
            Me.Refresh()
        End If
    End Sub

    Public Sub closeconnection()
        If connect.State = ConnectionState.Open Then
            connect.Close()
        ElseIf connect.State = ConnectionState.Closed Then
            Me.Refresh()
        End If
    End Sub
#End Region

#Region "Minimize Button"
    Private Sub btnMinimize_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnMinimize.Click
        If Me.WindowState = FormWindowState.Normal Then
            Me.WindowState = FormWindowState.Minimized
        Else
            Me.Refresh()
        End If
    End Sub
#End Region

#Region "Close Button"
    Private Sub btnClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClose.Click
        Me.Dispose()
        Me.Close()
    End Sub
#End Region

#Region "Browse Button"
    Private Sub btnBrowse_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnBrowse.Click
        hidelabels()
        hideeditvalues()
        lblEditreference.Text = "edit"
        With ofdBrowse
            .Title = "Select picture"
            .FileName = ""
            .Filter = "All Image Types (*.jpg, *.jpeg, *.png, *.tif, *.gif)|*.jpg; *.jpeg; *.png; *.tif; *.gif"
        End With
        If ofdBrowse.ShowDialog = Windows.Forms.DialogResult.Cancel Then
            Me.Refresh()
        End If
    End Sub
#End Region

#Region "Save Button"
    Private Sub btnSave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSave.Click
        hidelabels()
        If lblPicname.Text <> "save" Then
            Dim fsreader As New FileStream(ofdBrowse.FileName, FileMode.Open, FileAccess.Read)
            Dim breader As New BinaryReader(fsreader)
            Dim imgbuffer(fsreader.Length) As Byte
            breader.Read(imgbuffer, 0, fsreader.Length)
            fsreader.Close()
            Dim picname As String = lblPicname.Text
            Dim savedate As String = lblDate.Text
            Dim savetime As String = lblTime.Text
            openconnection()
            Dim insertqry As String = "INSERT INTO pictures(picname,pic,savedate,savetime) VALUES(@picname,@pic,@savedate,@savetime)"
            Dim insertcmd As New OleDbCommand
            With insertcmd
                .CommandText = insertqry
                .Connection = connect
                .Parameters.AddWithValue("@picname", picname)
                .Parameters.AddWithValue("@pic", imgbuffer)
                .Parameters.AddWithValue("@savedate", savedate)
                .Parameters.AddWithValue("@savetime", savetime)
                Try
                    .ExecuteNonQuery()
                    MsgBox("Picture saved", MsgBoxStyle.Information, "Success")
                    .Dispose()
                    lblPicname.Text = "save"
                    lblPicname.Hide()
                    closeconnection()
                    hideeditvalues()
                    hidelabels()
                    allpics()
                    lblEditreference.Text = "edit"
                    Exit Sub
                Catch ex As Exception
                    MsgBox(ex.Message)
                    closeconnection()
                    'MsgBox("Error occured. Please try again", MessageBoxIcon.Error, "Error")
                    Exit Sub
                End Try

            End With

        ElseIf lblPicname.Text = "save" Then
            MsgBox("Select browse for a picture first", MessageBoxIcon.Error, "Error")
            btnBrowse.Focus()
            Exit Sub
        End If

    End Sub
#End Region

#Region "Refresh Button"
    Private Sub btnRefresh_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnRefresh.Click
        lblPicname.Text = "save"
        hidelabels()
        allpics()
        hideeditvalues()
        lblEditreference.Text = "edit"
    End Sub
#End Region

#Region "Delete Button"
    Private Sub btnDelete_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDelete.Click
        lblPicname.Text = "save"

        If lblEditreference.Text = "edit" Then
            MsgBox("Please select a picture from right", MessageBoxIcon.Error, "Error")
            Exit Sub
        Else
            Dim result As String = MessageBox.Show("Are you sure you want to delete this picture?", "Confirm Delete", MessageBoxButtons.YesNo, MessageBoxIcon.Question, MessageBoxDefaultButton.Button2)
            If result = MsgBoxResult.No Then
                Me.Refresh()
            Else
                openconnection()
                Dim updateqry As String = "DELETE FROM pictures WHERE id=" + lblEditreference.Text
                Dim updatecmd As New OleDbCommand
                With updatecmd
                    .CommandText = updateqry
                    .Connection = connect
                    Try
                        .ExecuteNonQuery()
                        MsgBox("Picture deleted", MsgBoxStyle.Information, "Success")
                        hidelabels()
                        hideeditvalues()
                        lblEditreference.Text = "edit"
                        closeconnection()
                        allpics()
                        Exit Sub
                    Catch ex As Exception
                        MsgBox(ex.Message)
                        closeconnection()
                        hidelabels()
                        hideeditvalues()
                        lblEditreference.Text = "edit"
                        MsgBox("Error occured. Please try again", MessageBoxIcon.Error, "Error")
                        Exit Sub
                    End Try
                End With
            End If
            
        End If
    End Sub
#End Region

#Region "Edit Button"
    Private Sub btnEdit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnEdit.Click
        lblPicname.Text = "save"

        If lblEditreference.Text = "edit" Then
            MsgBox("Please select a picture from right", MessageBoxIcon.Error, "Error")
            Exit Sub
        Else
            showeditvalues()
        End If

    End Sub
#End Region

#Region "Check Updates Button"
    Private Sub btnCheckupdates_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCheckupdates.Click
        lblPicname.Text = "save"
        hideeditvalues()
        lblEditreference.Text = "edit"
        
        Me.Enabled = False

        Dim response As System.Net.HttpWebResponse
        Try
            Dim request As System.Net.HttpWebRequest = System.Net.HttpWebRequest.Create("https://googledrive.com/host/0BzlScedc3p2fUEQ0MjJFa1cxUWM/Tool Update.txt")
            response = request.GetResponse()
        Catch ex As Exception
            MsgBox("Error occured. Please try again", MessageBoxIcon.Warning, "Error")
            Me.Enabled = True
            Exit Sub
        End Try
        Dim sr As StreamReader = New StreamReader(response.GetResponseStream())

        Dim newsoftversion As String = sr.ReadToEnd()
        Dim currentsoftversion As String = Application.ProductVersion

        If newsoftversion.Contains(currentsoftversion) Then
            MsgBox("You have updated software version", MsgBoxStyle.Information, "Up to date")
            Me.Enabled = True
        Else
            Dim updatesoft As String
            updatesoft = MessageBox.Show("There is a new software version. Do you want to update now?", "Update available", MessageBoxButtons.YesNo, MessageBoxIcon.Question, MessageBoxDefaultButton.Button1)
            If updatesoft = MsgBoxResult.Yes Then
                System.Diagnostics.Process.Start("https://googledrive.com/host/0BzlScedc3p2fUEQ0MjJFa1cxUWM/Stationary Information System.exe")
                Me.Enabled = True
            Else
                MsgBox("Update cancelled", MsgBoxStyle.Information, "Cancel")
                Me.Enabled = True
            End If

        End If
    End Sub
#End Region

#Region "Help Button"
    Private Sub btnHelp_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnHelp.Click
        lblPicname.Text = "save"
        hidelabels()
        hideeditvalues()
        lblEditreference.Text = "edit"
        MsgBox("Kindly read the manual document", MsgBoxStyle.Information, "Help")
    End Sub
#End Region

#Region "About Button"
    Private Sub btnAbout_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAbout.Click
        lblPicname.Text = "save"
        hidelabels()
        hideeditvalues()
        lblEditreference.Text = "edit"
        MsgBox("Kindly read the manual document", MsgBoxStyle.Information, "About")
    End Sub
#End Region

#Region "Update Details Button"
    Private Sub btnUpdate_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnUpdate.Click
        lblPicname.Text = "save"

        Dim picname As String = txtPicname.Text.Trim
        Dim updatetime As String = lblTime.Text
        Dim updatedate As String = lblDate.Text

        If lblEditreference.Text = "edit" Then
            MsgBox("Please select a picture from right", MessageBoxIcon.Error, "Error")
            Exit Sub
        Else
            If picname = "" Then
                MsgBox("Please enter picture name", MessageBoxIcon.Error, "Error")
                txtPicname.Focus()
                Exit Sub
            ElseIf picname.Length <= 1 Then
                MsgBox("Please enter picture name correctly", MessageBoxIcon.Error, "Error")
                txtPicname.Focus()
                Exit Sub
            Else
                openconnection()
                Dim updateqry As String = "UPDATE pictures SET picname='" + picname + "',updatedate='" + updatedate + "',updatetime='" + updatetime + "' WHERE id=" + lblEditreference.Text
                Dim updatecmd As New OleDbCommand
                With updatecmd
                    .CommandText = updateqry
                    .Connection = connect
                    Try
                        .ExecuteNonQuery()
                        MsgBox("Picture updated", MsgBoxStyle.Information, "Success")
                        hidelabels()
                        hideeditvalues()
                        lblEditreference.Text = "edit"
                        closeconnection()
                        allpics()
                        Exit Sub
                    Catch ex As Exception
                        MsgBox(ex.Message)
                        closeconnection()
                        hidelabels()
                        hideeditvalues()
                        lblEditreference.Text = "edit"
                        MsgBox("Error occured. Please try again", MessageBoxIcon.Error, "Error")
                        Exit Sub
                    End Try
                End With
            End If
        End If

    End Sub
#End Region

#Region "Search Button"
    Private Sub btnSearch_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSearch.Click
        Dim search As String = txtSearch.Text.Trim
        If (search = "" Or IsNothing(search) = True) Then
            MsgBox("Please enter something to search", MessageBoxIcon.Error, "Error")
            txtSearch.Focus()
        Else
            openconnection()
            Dim searchqry As String = "SELECT * FROM pictures WHERE id LIKE '%" + search + "%' OR picname LIKE '%" + search + "%' OR savedate LIKE '%" + search + "%' OR savetime LIKE '%" + search + "%' OR updatedate LIKE '%" + search + "%' OR updatetime LIKE '%" + search + "%'"
            Dim da As OleDbDataAdapter
            da = New OleDbDataAdapter(searchqry, connect)
            Dim dtset As DataSet
            dtset = New DataSet
            Try
                da.Fill(dtset, "pictures")
            Catch ex As Exception
                MsgBox("Error occured. Please try again", MessageBoxIcon.Error, "Error")
                Exit Sub
            End Try
            Dim dttable As DataTable
            dttable = New DataTable
            dttable = dtset.Tables("pictures")

            dgvPics.DataSource = dttable
            dgvPics.ColumnHeadersDefaultCellStyle.Font = New Font(dgvPics.Font, FontStyle.Bold)

            dgvPics.Columns("ID").HeaderText = "S/N"
            dgvPics.Columns("picname").HeaderText = "Picture Name"
            dgvPics.Columns("pic").HeaderText = "Picture"
            dgvPics.Columns("savedate").HeaderText = "Date Saved"
            dgvPics.Columns("savetime").HeaderText = "Time Saved"
            dgvPics.Columns("updatedate").HeaderText = "Date Updated"
            dgvPics.Columns("updatetime").HeaderText = "Time Updated"

            closeconnection()
            txtSearch.Clear()
        End If
    End Sub
#End Region

#Region "When form loads"
    Private Sub frmMain_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        tTime.Start()
        tTime.Interval = 1
        lblPicname.Text = "save"

        Try
            allpics()
        Catch ex As Exception
            Me.Close()
        End Try

        lblEditreference.Text = "edit"
        hidelabels()
        hideeditvalues()
    End Sub
#End Region

#Region "OFD File ok"
    Private Sub ofdBrowse_FileOk(ByVal sender As System.Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles ofdBrowse.FileOk
        Dim picname As String = Path.GetFileNameWithoutExtension(ofdBrowse.FileName)
        Dim piclocation As String = Path.GetFullPath(ofdBrowse.FileName)
        pbPic.ImageLocation = piclocation
        lblPicname.Show()
        lblPicname.Text = picname
    End Sub
#End Region

#Region "Time and Date"
    Private Sub tTime_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tTime.Tick
        lblTime.Text = TimeOfDay
        lblDate.Text = Today.Date.ToString("dd/MM/yyyy")
    End Sub
#End Region

#Region "View All pictures"
    Private Sub allpics()
        openconnection()
        Dim selectqry As String = "SELECT * FROM pictures"
        Dim da As OleDbDataAdapter
        da = New OleDbDataAdapter(selectqry, connect)
        Dim dtset As DataSet
        dtset = New DataSet
        Try
            da.Fill(dtset, "pictures")
        Catch ex As Exception
            MsgBox("Error occured. Please try again", MessageBoxIcon.Error, "Error")
            Exit Sub
        End Try
        Dim dttable As DataTable
        dttable = New DataTable
        dttable = dtset.Tables("pictures")

        dgvPics.DataSource = dttable
        dgvPics.ColumnHeadersDefaultCellStyle.Font = New Font(dgvPics.Font, FontStyle.Bold)

        dgvPics.Columns("ID").HeaderText = "S/N"
        dgvPics.Columns("picname").HeaderText = "Picture Name"
        dgvPics.Columns("pic").HeaderText = "Picture"
        dgvPics.Columns("savedate").HeaderText = "Date Saved"
        dgvPics.Columns("savetime").HeaderText = "Time Saved"
        dgvPics.Columns("updatedate").HeaderText = "Date Updated"
        dgvPics.Columns("updatetime").HeaderText = "Time Updated"

        closeconnection()
    End Sub

#End Region

#Region "When click on picture"
    Private Sub dgvPics_CellContentClick(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DataGridViewCellEventArgs) Handles dgvPics.CellContentClick
        showlables()
        Dim s As System.Drawing.Point
        s = dgvPics.CurrentCellAddress
        Dim dbid As String = dgvPics.Item("id", s.Y).Value.ToString
        lblEditreference.Text = dbid
        lblDBid.Text = dbid

        Dim dbpicname As String = dgvPics.Item("picname", s.Y).Value.ToString
        lblDBname.Text = dbpicname
        txtPicname.Text = dbpicname

        Dim dbpic() As Byte = dgvPics.Item("pic", s.Y).Value
        Dim ms As MemoryStream
        ms = New MemoryStream(dbpic)
        Dim img As Image = Image.FromStream(ms)
        pbDBpic.Image = img

        Dim dbsavedate As String = dgvPics.Item("savedate", s.Y).Value.ToString
        lblDBdatesave.Text = dbsavedate

        Dim dbsavetime As String = dgvPics.Item("savetime", s.Y).Value.ToString
        lblDBtimesave.Text = dbsavetime

        Dim dbupdatetime As String = dgvPics.Item("updatetime", s.Y).Value.ToString
        lblDBupdatetime.Text = dbupdatetime

        Dim dbupdatedate As String = dgvPics.Item("updatedate", s.Y).Value.ToString
        lblDBupdatedate.Text = dbupdatedate
    End Sub
#End Region

#Region "show labels"
    Private Sub showlables()
        lblDBid.Show()
        lblDBname.Show()
        lblDBtimesave.Show()
        lblDBdatesave.Show()
        lblDBupdatetime.Show()
        lblDBupdatedate.Show()
        pbDBpic.Show()

        LabelID.Show()
        LabelName.Show()
        LabelSavet.Show()
        LabelSaved.Show()
        LabelUpdatet.Show()
        LabelUpdated.Show()
    End Sub
#End Region

#Region "hide labels"
    Private Sub hidelabels()
        lblDBid.Hide()
        lblDBname.Hide()
        lblDBtimesave.Hide()
        lblDBdatesave.Hide()
        lblDBupdatetime.Hide()
        lblDBupdatedate.Hide()
        pbDBpic.Hide()

        LabelID.Hide()
        LabelName.Hide()
        LabelSavet.Hide()
        LabelSaved.Hide()
        LabelUpdatet.Hide()
        LabelUpdated.Hide()
    End Sub
#End Region

#Region "Show Edit functions"
    Private Sub showeditvalues()
        Label1.Show()
        txtPicname.Show()
        btnUpdate.Show()
    End Sub
#End Region

#Region "Hide Edit functions"
    Private Sub hideeditvalues()
        Label1.Hide()
        txtPicname.Hide()
        btnUpdate.Hide()
    End Sub
#End Region

End Class
